com.ihr.xbrl.util

## Class OEM

- java.lang.Object
- - com.ihr.xbrl.util.OEM

-     public final class OEM
      extends java.lang.Object

  This class contains static information for the OEM So it is possible for the OEMs to define their own taxonomy catalog and replace ReportingStandard Catalog.
  Author:
    Ignacio

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `ChangeGUIOptions` Check for OEMs that do not allow to change the GUI options.
    `static java.lang.String` | `ChangeProcessorsOptions` Check for OEMs that do not allow to change the processor options.
    `static java.lang.String` | `RS` This is Reporting Standard as OEM.
    `static java.lang.String` | `RSCompanyNameEdit` The Constant RSCompanyNameEdit.
    `static java.lang.String` | `RSCompanyNameLabel` The Constant RSCompanyNameLabel.
    `static java.lang.String` | `RSCompanyNameTooltip` The Constant RSCompanyNameTooltip.
    `static java.lang.String` | `RSCustomLogo` The Constant RSCustomLogo.
    `static java.lang.String` | `RSCustomRequestCompanies` The Constant RSCustomRequestCompanies.
    `static java.lang.String` | `RSDefaultShemeURI` This is the key for the default scheme associated with an OEM.
    `static java.lang.String` | `RSFixedUnit` If the project does not allows to change units, this property is assigned to the monetary unit that shall be used.
    `static java.lang.String` | `RSIdentifierFormatter` The Constant RSIdentifierFormatter.
    `static java.lang.String` | `RSMessageBeforeSaveCleanMessage` Message to be sent to the user when the instance is clean for specific projects.
    `static java.lang.String` | `RSPrintMenu` The Constant RSPrintMenu.
    `static java.lang.String` | `RSRemoteCatalogURL` This is the key for the URL where the remote catalog is stored.
    `static java.lang.String` | `RSSaveAs` The Constant RSSaveAs.
    `static java.lang.String` | `RSSchemeVisible` This is the key for the Scheme Visible property.
    `static java.lang.String` | `RSShowInstanceFileNameAfterSave` this is "true" when the application shall show a message after the instance has been saved on disk.
    `static java.lang.String` | `RSTaxonomyDoubleClickOpenFileContent` The Constant RSTaxonomyDoubleClickOpenFileContent.
    `static java.lang.String` | `URIFromCatalog` Check for OEMs that limits access to add a URI from Catalog.
    `static java.lang.String` | `URIFromDB` Check for OEMs that limits access to add a URI from database.
    `static java.lang.String` | `URIFromInternet` Check for OEMs that limits access to add a URI from Internet.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OEM()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.String` | `getCompanyNameEditText(java.lang.String defaultText)` Some projects may redefine the text in the edit company name button.
    `static java.lang.String` | `getCompanyNameLabel(java.lang.String defaultText)` Some projects may redefine the company name label to something like "NIT" or "RUT" or "RUC" or "NIF"...
    `static java.lang.String` | `getCompanyNameTooltip(java.lang.String defaultText)` Some projects may redefine the company name tooltip .
    `static java.lang.String` | `getDlgRequestCompaniesClass()` Gets the dlg request companies class.
    `static javax.swing.JFormattedTextField.AbstractFormatter` | `getIdentifierFormatter()` Some projects may define specific formatters for the company identifier.
    `static java.lang.String` | `getMessageBeforeSaveCleanMessage()` Gets the message before save clean message.
    `static java.lang.String` | `getOEM()` Access to the OEM name from the license.
    `static javax.xml.namespace.QName` | `getOemDefinedUnit()` Gets the oem defined unit.
    `static java.lang.String` | `getOEMLogoURL(java.lang.String extension)` Gets the OEM logo url.
    `static java.lang.String` | `getStaticCatalogURL()` Access to the value of the URL where the static catalog is stored considering the OEM may have a different value hard coded in this class .
    `static java.net.URI` | `getStaticDefaultScheme()` Access to the value of the scheme used for this license.
    `static boolean` | `isSchemeVisible()` Access to a property that indicates if the scheme is visible to users filing a value for a new instance document in the Express tool.
    `static boolean` | `isTaxonomyDoubleClickOpenFileContent()` Checks if is taxonomy double click open file content.
    `static boolean` | `RSAccess(java.lang.String key)` Returns true if the property is NOT defined or it is defined with a value other than "false".
    `static java.util.Properties` | `setPropertiesToOEMDefault(java.util.Properties props)` This method is called after properties has been set to default properties in the DTSContainer class.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### RSRemoteCatalogURL

          public static final java.lang.String RSRemoteCatalogURL

      This is the key for the URL where the remote catalog is stored. OEMs may define their own property value
      See Also:
        Constant Field Values

    - #### RSDefaultShemeURI

          public static final java.lang.String RSDefaultShemeURI

      This is the key for the default scheme associated with an OEM.
      See Also:
        Constant Field Values

    - #### RSSchemeVisible

          public static final java.lang.String RSSchemeVisible

      This is the key for the Scheme Visible property.
      See Also:
        Constant Field Values

    - #### RSCompanyNameLabel

          public static final java.lang.String RSCompanyNameLabel

      The Constant RSCompanyNameLabel.
      See Also:
        Constant Field Values

    - #### RSCompanyNameTooltip

          public static final java.lang.String RSCompanyNameTooltip

      The Constant RSCompanyNameTooltip.
      See Also:
        Constant Field Values

    - #### RSCompanyNameEdit

          public static final java.lang.String RSCompanyNameEdit

      The Constant RSCompanyNameEdit.
      See Also:
        Constant Field Values

    - #### RSIdentifierFormatter

          public static final java.lang.String RSIdentifierFormatter

      The Constant RSIdentifierFormatter.
      See Also:
        Constant Field Values

    - #### RSMessageBeforeSaveCleanMessage

          public static final java.lang.String RSMessageBeforeSaveCleanMessage

      Message to be sent to the user when the instance is clean for specific projects. If this property does not exists the RSAccess method returns true
      See Also:
        Constant Field Values

    - #### RSShowInstanceFileNameAfterSave

          public static final java.lang.String RSShowInstanceFileNameAfterSave

      this is "true" when the application shall show a message after the instance has been saved on disk. Default value is "false"
      See Also:
        Constant Field Values

    - #### RSPrintMenu

          public static final java.lang.String RSPrintMenu

      The Constant RSPrintMenu.
      See Also:
        Constant Field Values

    - #### RSSaveAs

          public static final java.lang.String RSSaveAs

      The Constant RSSaveAs.
      See Also:
        Constant Field Values

    - #### RSFixedUnit

          public static final java.lang.String RSFixedUnit

      If the project does not allows to change units, this property is assigned to the monetary unit that shall be used.
      See Also:
        Constant Field Values

    - #### RS

          public static final java.lang.String RS

      This is Reporting Standard as OEM. Used as default value
      See Also:
        Constant Field Values

    - #### URIFromCatalog

          public static final java.lang.String URIFromCatalog

      Check for OEMs that limits access to add a URI from Catalog.
      See Also:
        Constant Field Values

    - #### URIFromInternet

          public static final java.lang.String URIFromInternet

      Check for OEMs that limits access to add a URI from Internet.
      See Also:
        Constant Field Values

    - #### URIFromDB

          public static final java.lang.String URIFromDB

      Check for OEMs that limits access to add a URI from database.
      See Also:
        Constant Field Values

    - #### ChangeProcessorsOptions

          public static final java.lang.String ChangeProcessorsOptions

      Check for OEMs that do not allow to change the processor options.
      See Also:
        Constant Field Values

    - #### RSCustomRequestCompanies

          public static final java.lang.String RSCustomRequestCompanies

      The Constant RSCustomRequestCompanies.
      See Also:
        Constant Field Values

    - #### RSCustomLogo

          public static final java.lang.String RSCustomLogo

      The Constant RSCustomLogo.
      See Also:
        Constant Field Values

    - #### ChangeGUIOptions

          public static final java.lang.String ChangeGUIOptions

      Check for OEMs that do not allow to change the GUI options.
      See Also:
        Constant Field Values

    - #### RSTaxonomyDoubleClickOpenFileContent

          public static final java.lang.String RSTaxonomyDoubleClickOpenFileContent

      The Constant RSTaxonomyDoubleClickOpenFileContent.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### OEM

          public OEM()

  - ### Method Detail

    - #### getOEM

          public static final java.lang.String getOEM()

      Access to the OEM name from the license.
      Returns:
        the oem

    - #### setPropertiesToOEMDefault

          public static final java.util.Properties setPropertiesToOEMDefault(java.util.Properties props)

      This method is called after properties has been set to default properties in the DTSContainer class. The idea is to set properties as indicated by the OEM licensing so the users can no longer worry about what the proper values are.
      Parameters:
        `props` - the props
      Returns:
        the properties

    - #### getStaticCatalogURL

          public static final java.lang.String getStaticCatalogURL()

      Access to the value of the URL where the static catalog is stored considering the OEM may have a different value hard coded in this class .
      Returns:
        the static catalog url

    - #### getStaticDefaultScheme

          public static final java.net.URI getStaticDefaultScheme()

      Access to the value of the scheme used for this license. This method considers the OEM may have one assigned value
      Returns:
        the static default scheme

    - #### isSchemeVisible

          public static final boolean isSchemeVisible()

      Access to a property that indicates if the scheme is visible to users filing a value for a new instance document in the Express tool. The Scheme may be hidden if the project requires so
      Returns:
        true, if is scheme visible

    - #### RSAccess

          public static boolean RSAccess(java.lang.String key)

      Returns true if the property is NOT defined or it is defined with a value other than "false".
      Parameters:
        `key` - the key
      Returns:
        boolean value to facilitate tool customization

    - #### getCompanyNameLabel

          public static java.lang.String getCompanyNameLabel(java.lang.String defaultText)

      Some projects may redefine the company name label to something like "NIT" or "RUT" or "RUC" or "NIF"...
      Parameters:
        `defaultText` - the default text
      Returns:
        the company name label

    - #### getCompanyNameTooltip

          public static java.lang.String getCompanyNameTooltip(java.lang.String defaultText)

      Some projects may redefine the company name tooltip .
      Parameters:
        `defaultText` - the default text
      Returns:
        the company name tooltip

    - #### getCompanyNameEditText

          public static java.lang.String getCompanyNameEditText(java.lang.String defaultText)

      Some projects may redefine the text in the edit company name button.
      Parameters:
        `defaultText` - the default text
      Returns:
        the company name edit text

    - #### getIdentifierFormatter

          public static javax.swing.JFormattedTextField.AbstractFormatter getIdentifierFormatter()

      Some projects may define specific formatters for the company identifier.
      Returns:
        the identifier formatter

    - #### isTaxonomyDoubleClickOpenFileContent

          public static boolean isTaxonomyDoubleClickOpenFileContent()

      Checks if is taxonomy double click open file content.
      Returns:
        true, if is taxonomy double click open file content

    - #### getMessageBeforeSaveCleanMessage

          public static java.lang.String getMessageBeforeSaveCleanMessage()

      Gets the message before save clean message.
      Returns:
        the message before save clean message

    - #### getOemDefinedUnit

          public static javax.xml.namespace.QName getOemDefinedUnit()

      Gets the oem defined unit.
      Returns:
        the oem defined unit

    - #### getDlgRequestCompaniesClass

          public static java.lang.String getDlgRequestCompaniesClass()

      Gets the dlg request companies class.
      Returns:
        the dlg request companies class

    - #### getOEMLogoURL

          public static java.lang.String getOEMLogoURL(java.lang.String extension)

      Gets the OEM logo url.
      Parameters:
        `extension` - the extension
      Returns:
        the OEM logo url